package com.sqlitecrypt.sqlitecryptandroid;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.content.Context;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.database.Cursor;
import com.sqlitecrypt.database.SQLiteDatabase;
import java.io.File;
import com.sqlitecrypt.database.SQLiteOpenHelper;


public class ButtonActivity extends AppCompatActivity implements View.OnClickListener{

    private LinearLayout linearLayout = null;

    // Button1 and button2 is added in layout xml file.
    private Button button1 = null;
    private Button button2 = null;
    private Button button3 = null;
    private Button button4 = null;
    private Button button5 = null;

    private Context context = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_button);

        setTitle("SQLiteCrypt Android Example.");

        initControls();
        SQLiteDatabase.loadLibs(this);
    }


    /* Initialise layout and button components. */
    private void initControls()
    {
        if(button1 == null)
        {
            button1 = (Button)findViewById(R.id.button_1);
        }

        if(button2 == null)
        {
            button2 = (Button)findViewById(R.id.button_2);
        }

        if(button3 == null)
        {
            button3 = (Button)findViewById(R.id.button_3);
        }

        if(button4 == null)
        {
            button4 = (Button)findViewById(R.id.button_4);
        }

        if(button5 == null)
        {
            button5 = (Button)findViewById(R.id.button_5);
        }

        if(context == null)
        {
            context = getApplicationContext();
        }

        /* Must set the on click listener to this activity,
           otherwise the override onClick method will bot be invoked.*/
        button1.setOnClickListener(this);
        button2.setOnClickListener(this);
        button3.setOnClickListener(this);
        button4.setOnClickListener(this);
        button5.setOnClickListener(this);
    }


    /* This method is called when any of the activity's view components is clicked. */
    @Override
    public void onClick(View view) {
        if(view != null)
        {
            String message = "";

            // Get view component id.
            int id = view.getId();

            File dbFile = this.getDatabasePath("test.db");
            String dbPath = dbFile.getPath();
            if(!dbFile.exists()) {
                new File(dbFile.getParent()).mkdirs();
            }
            // Show different message when click different view component.
            if(id == R.id.button_1)
            {
                //message = "Button one is clicked.";
                context.deleteDatabase(dbPath);
                SQLiteDatabase db;

                db=SQLiteDatabase.openOrCreateDatabase(dbPath, "", null);
                db.execSQL("CREATE TABLE IF NOT EXISTS student(id INT,name VARCHAR);");
                db.execSQL("insert into student(id,name) VALUES(1, 'Sparta');");
                Cursor c=db.rawQuery("SELECT * FROM student", null);
                if(c.moveToFirst())
                {
                    message = "Student #" + c.getInt(0) + ": " + c.getString(1);
                    button2.setEnabled(true);
                }
                else
                {
                    message = "DB creation failed";
                }
                button3.setEnabled(false);
            }else if(id == R.id.button_2)
            {
                //message = "Button two is clicked.";
                SQLiteDatabase db;
                db=SQLiteDatabase.openOrCreateDatabase(dbPath, "", null);
                db.changePassword("abc123");
                Cursor c=db.rawQuery("SELECT * FROM student", null);
                if(c.moveToFirst())
                {
                    message = "DB encryption success, student #" + c.getInt(0) + ": " + c.getString(1);
                }
                else
                {
                    message = "DB encryption failed";
                }
                button2.setEnabled(false);
                button3.setEnabled(true);
                button4.setEnabled(true);
            }else if(id == R.id.button_3)
            {
                SQLiteDatabase db;
                db=SQLiteDatabase.openOrCreateDatabase(dbPath, "abc123", null);
                Cursor c=db.rawQuery("SELECT * FROM student", null);
                if(c.moveToFirst())
                {
                    message = "Query encrypted db success, student #" + c.getInt(0) + ": " + c.getString(1);
                }
                else
                {
                    message = "Query encrypted db failed";
                }
            }
            else if(id == R.id.button_4)
            {
                SQLiteDatabase db;
                db=SQLiteDatabase.openOrCreateDatabase(dbPath, "abc123", null);
                db.changePassword("");
                Cursor c=db.rawQuery("SELECT * FROM student", null);
                if(c.moveToFirst())
                {
                    message = "Db decrypted, student #" + c.getInt(0) + ": " + c.getString(1);
                }
                else
                {
                    message = "Db decryption failed";
                }
                button3.setEnabled(false);
                button4.setEnabled(false);
                button5.setEnabled(true);
            }
            else if(id == R.id.button_5)
            {
                SQLiteDatabase db;
                db=SQLiteDatabase.openOrCreateDatabase(dbPath, "", null);
                Cursor c=db.rawQuery("SELECT * FROM student", null);
                if(c.moveToFirst())
                {
                    message = "Query regular db success, student #" + c.getInt(0) + ": " + c.getString(1);
                }
                else
                {
                    message = "Query regular db failed";
                }
            }

            // Create the toast popup message.
            Toast toast = Toast.makeText(context, message, Toast.LENGTH_SHORT);
            toast.setGravity(Gravity.CENTER, 0, 0);
            toast.show();
        }
    }
}